from datetime import datetime
from appPublic.uniqueID import getID
from sqlor.dbpools import DBPools
from appPublic.timeUtils import curDateString
from appPublic.argsConvert import ArgsConvert
from .accounting_config import get_accounting_config, AccountingOrgs
from .const import *
from .accountingnode import get_accounting_nodes
from .excep import *
from .getaccount import getAccountByName
from .businessdate import get_business_date

class ConsumeAccounting:
	def __init__(self, cnsume_log):
		self.db = DBPools()
		self.recharge_log = recharge_log
		self.customerid = recharge_log['customerid']
		self.orderid = None
		self.curdate = recharge_log['recharge_date']
		self.transamount = recharge_log['recharge_amt']
		self.timestamp = datetime.now()
		self.productid = None
		self.providerid = None
		self.action = recharge_log['action']
		self.summary = self.action
		self.billid = getID()
		self.bill = {
			'id':self.billid,
			'customerid':self.recharge_log['customerid'],
			'resellerid':None,
			'orderid':None,
			'business_op':self.recharge_log['action'],
			'amount':self.recharge_log['recharge_amt'],
			'bill_date':self.curdate,
			'bill_timestamp':self.timestamp
		}
	
	
	async def accounting(self, sor):
		self.sor = sor
		bz_date = await get_business_date(sor=sor)
		if bz_date != self.curdate:
			raise AccountingDateNotInBusinessDate(self.curdate, bz_date)

		nodes = await get_accounting_nodes(sor, self.customerid)
		lst = len(nodes) - 1
		self.accountingOrgs = []
		for i, n in enumerate(nodes):
			if i < lst:
				ao = AccountingOrgs(self, nodes[i], self.customerid, 
											resellerid=nodes[i+1])
			else:
				ao = AccountingOrgs(self, nodes[i], self.customerid)
			self.accountingOrgs.append(ao)
		await self.write_bill(sor)
		[await ao.do_accounting(sor) for ao in self.accountingOrgs ]
		print(f'recharge ok for {self.bill}, {nodes=}')
		return True

	async def write_bill(self, sor):
		await sor.C('bill', self.bill.copy())
		# await sor.C('recharge_log', self.recharge_log.copy())

